/* Simple DBM style database */

DBM := Object clone do(
    type := "DBM"
    
    newSlot("sqliteProto", SQLite)
    
    init := method(
	self db := sqliteProto clone
    )

    open := method(name,
	dbName := name .. ".sqlite"
	    if(File clone setPath(dbName) exists, 
	    db open(dbName)
	) else (
	    db open(dbName)
	    db exec("CREATE TABLE DBM (key, value)")
	    db exec("CREATE INDEX DBMIndex ON DBM (key)")
	)
	self
    )

    close := method(db close; self)

    atPut := method(key, value,
	/* add code to escape single quotes */
	if (self at(key),
	    cmd := "UPDATE DBM SET value := '" .. value .."' WHERE key='" .. key .. "'"
	) else (
	    cmd := "INSERT INTO DBM (key, value) VALUES ('" .. key .. "', '" .. value .."')"
	)
	/*write("cmd := ", cmd, "\n")*/
	db exec(cmd)
	self
    )

    at := method(key,
	cmd := "SELECT value FROM DBM WHERE key='" .. key .. "'"
	/*write("cmd := ", cmd, "\n")*/
	results := db exec(cmd)
	/*write("[size := ", results size, "]")*/
	if (results size == 0, return Nil)
	results at(0) at("value")
    )
)