/*
 docCopyright("Steve Dekorte", 2002)
 docLicense("BSD revised")
 */

#include "PortableSocket.h"

void PortableSocket_ignoreSignal(int sig) 
{
}

void PortableSocket_init(void)
{
#ifndef WIN32
    signal(SIGPIPE, PortableSocket_ignoreSignal);
#endif
}

int PortableSocket_makeAsync(int descriptor)
{
#ifdef WIN32
    unsigned long nonzero = 1;
    if (ioctlsocket(descriptor, FIONBIO, &nonzero)==-1)
#else
	if (fcntl(descriptor, F_SETFL, FASYNC | O_NONBLOCK)==-1) 
#endif
	{ return -1; }
	    return 0;
}

int PortableSocket_read(int descriptor, unsigned char *buffer, int readSize)
{ 
#ifdef WIN32
    return recv(descriptor, buffer, readSize, 0);
#else
    return read(descriptor, buffer, readSize);
#endif
}

int PortableSocket_write(int descriptor, unsigned char *buffer, int writeSize)
{
#ifdef WIN32
    return send(descriptor, buffer, writeSize, 0);
#else
    return write(descriptor, buffer, writeSize);
#endif
}

int PortableSocket_close(int descriptor)
{
#ifdef WIN32
    if (descriptor != INVALID_SOCKET)
	return closesocket(descriptor);
    else
	return 0;
#else
    return close(descriptor);
#endif
}

int PortableSocket_openReadOnlyNonBlockingAtPath_(char *path)
{
#ifdef WIN32
    return -1;
#else
    return open(path, O_RDONLY | O_NONBLOCK);
#endif
}

