/*
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
docDescription("See the release notes for a list of folks that helped with this code.")
*/

#ifndef PORTABLESOCKET_DEFINED
#define PORTABLESOCKET_DEFINED 1

    #include <sys/types.h>

    #ifndef WIN32
	#include <sys/uio.h>
	#include <sys/types.h>
	#include <unistd.h>
	#include <sys/socket.h>
	#include <netinet/in.h>
	#include <arpa/inet.h>
	#include <netdb.h>
	#include <signal.h>
	#include <sys/ioctl.h>
	#include <sys/time.h>
	#define myerrno errno
    #else
	#include <winsock2.h>
	#ifndef EISCONN
	    #define EISCONN WSAEISCONN
	    #define ENOTCONN WSAENOTCONN
	    #define myerrno WSAGetLastError()
	#endif
    #endif

#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>

#ifdef sun
#include <sys/file.h> /* for FASYNC */
#endif

#ifndef SOMAXCONN
#define SOMAXCONN 128
#endif

#ifdef WIN32
  typedef SOCKET SOCKET_DESCRIPTOR;
#else
  typedef int SOCKET_DESCRIPTOR;
#endif

void PortableSocket_init(void);

int PortableSocket_makeAsync(int descriptor);
int PortableSocket_read(int descriptor, unsigned char *buffer, int readSize);
int PortableSocket_write(int descriptor, unsigned char *buffer, int writeSize);
int PortableSocket_close(int descriptor);
int PortableSocket_openReadOnlyNonBlockingAtPath_(char *path);


#endif
