/*
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
*/

#ifndef IoCatch_DEFINED
#define IoCatch_DEFINED 1

#include "Common.h"
#include "Stack.h"
#include "IoSeq.h"
#include "IoException.h"
#include "Scheduler.h"

#ifdef __cplusplus
extern "C" {
#endif

#define ISCATCH(self) \
  IoObject_hasCloneFunc_(self, (TagCloneFunc *)IoCatch_rawClone)

typedef void *(IoCatchCallback)(void *, void *, void *);

typedef struct IoCatch IoCatch;

struct IoCatch
{
    void *state;
    IoCatch *previous; 
    ptrdiff_t stackMark; /* mark on coro retainStack when tried */
    jmp_buf *savedStack;
};

IoCatch *IoCatch_new(void *state);
void IoCatch_free(IoCatch *self);

void IoCatch_push(IoCatch *self);
void IoCatch_pop(IoCatch *self);

IoObject *IoCatch_tryFunc_(IoCatch *self, IoCatchCallback *func, 
  void *arg1, void *arg2, void *arg3, IoException **e);
void IoCatch_longJump(IoCatch *self);

#ifdef __cplusplus
}
#endif
#endif
