/*#io
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
*/

#ifndef IOCOROUTINE_DEFINED
#define IOCOROUTINE_DEFINED 1

#include "Common.h"
#include "Queue.h"
#include "Stack.h"
#include "Coro.h"
/*#include "IoCatch.h"*/
#include <time.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
    Coro *cid;
    Queue *queue; /* for Actors - queue of async messages to be processed */
    Stack *retainedValues;
    void *exceptionCatch;
    void *exception;
    time_t actorSleepTime; /* time when actor last processed a message, or 0 if active */
    int debuggingOn;
} IoCoroutine;

IoCoroutine *IoCoroutine_new(void);
void IoCoroutine_free(IoCoroutine *self);
void IoCoroutine_mark(IoCoroutine *self);

size_t IoCoroutine_memorySize(IoCoroutine *self);
void IoCoroutine_compact(IoCoroutine *self);

int IoCoroutine_retainingCount(IoCoroutine *self);
void IoCoroutine_show(IoCoroutine *self);

#define IoCoroutine_exception(self) self->exception;
#define IoCoroutine_exception_(self, value) self->exception = value;

#define IoCoroutine_exceptionCatch(self) self->exceptionCatch;
#define IoCoroutine_exceptionCatch_(self, value) self->exceptionCatch = value;

#ifdef __cplusplus
}
#endif
#endif
