/*#io
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
*/

#ifndef IOFUTURE_DEFINED
#define IOFUTURE_DEFINED 1

#include "Common.h"
#include "IoObject.h"
#include "IoState.h"
#include "IoMessage.h"

#ifdef __cplusplus
extern "C" {
#endif

#define ISFUTURE(self) (self->tag->cloneFunc==(TagCloneFunc*)IoFuture_rawClone)
#define ISWAITINGFUTURE(self) (ISFUTURE(self) && (!IoObject_hasProtos(self)))

typedef IoObject IoFuture;

typedef struct
{
    IoMessage *message;
    IoObject *creatorObject;
    IoObject *pausedObject;
} IoFutureData;

IoFuture *IoFuture_proto(void *state);
IoFuture *IoFuture_rawClone(IoFuture *self);
IoFuture *IoFuture_new(void *state);
IoFuture *IoFuture_newWithMessage_creatorObject_(IoState *state, IoMessage *message, IoObject *creatorObject);
void IoFuture_mark(IoFuture *self);
void IoFuture_free(IoFuture *self);
IoMessage *IoFuture_rawMessage(IoFuture *self);

void IoFuture_rawSetValue_(IoFuture *self, IoObject *v);
unsigned char IoFuture_isPausing_(IoFuture *self, IoObject *v);

IoObject *IoFuture_forward(IoFuture *self, IoObject *locals, IoMessage *m);
IoObject *IoFuture_setValue(IoFuture *self, IoObject *locals, IoMessage *m);
IoObject *IoFuture_isWaitingFuture(IoFuture *self, IoObject *locals, IoMessage *m);
int IoFuture_rawWaitOnResult(IoFuture *self);

#ifdef __cplusplus
}
#endif
#endif
