#include "IoState.h"
#include "IoObject.h"

void IoVMCodeInit(IoState *self, IoObject *context)
{
  char *s = "\n"
  "Object do(\n"
  "    docsSlot := method(\n"
  "	self hasSlot(\"docs\") ifNil(self docs := Object clone do(slots := Object clone))\n"
  "	self docs\n"
  "    )\n"
  "    \n"
  "    docSlot := method(k, v, \n"
  "	entry := Object clone \n"
  "	entry description := v asSymbol\n"
  "	if (k containsSeq(\"(\"), \n"
  "	    entry args := k afterSeq(\"(\") beforeSeq(\")\") split(\",\") map(v, v strip)\n"
  "	)	\n"
  "	self docsSlot slots setSlot(k beforeSeq(\"(\"), entry)\n"
  "\n"
  "	//self docsSlot slots setSlot(k beforeSeq(\"(\"), v)\n"
  "	//writeln(\"docSlot(\", k, \", \", self docsSlot slots getSlot(k), \")\")\n"
  "    )\n"
  "    \n"
  "    docCopyright := method(v, \n"
  "	k := thisMessage name asMutable removePrefix(\"doc\") makeFirstCharacterLowerCase\n"
  "	self docsSlot setSlot(k, v)\n"
  "    )\n"
  "    \n"
  "    docLicense := getSlot(\"docCopyright\")\n"
  "    docObject := getSlot(\"docCopyright\")\n"
  "    docDescription := getSlot(\"docCopyright\")\n"
  "    docCredits := getSlot(\"docCopyright\")\n"
  "    docInclude := getSlot(\"docCopyright\")\n"
  "    docDependsOn := getSlot(\"docCopyright\")\n"
  "\n"
  "    ioDoc := method(\n"
  "	//docsSlot\n"
  "	if(thisMessage argAt(0), self doMessage(thisMessage argAt(0)))\n"
  "    )\n"
  "\n"
  "\n"
  "    \n"
  "    docSlot(\"eval(...)\", \"Performs the argument (in the same manner as do() ) and returns the result. \")\n"
  "    eval := method(self doMessage(thisMessage argAt(0)))\n"
  "    \n"
  "    docSlot(\"list(...)\", \"Returns a List containing the arguments.\")\n"
  "    list := method(thisMessage argsEvaluatedIn(sender))\n"
  "    \n"
  "    docSlot(\"..(arg)\", \".. is an alias for: method(arg, self asString append(arg asString))\")\n"
  "    setSlot(\"..\", method(arg, self asString appendSeq(arg asString)))\n"
  "    \n"
  "    docSlot(\"newSlot(slotName, aValue)\", \n"
  "    \"\"\"Creates a getter and setter for the slot with the name slotName \n"
  "    and sets it's default the value aValue. Returns self. For example, \n"
  "    newSlot(\"foo\", 1) would create slot named foo with the value 1 as well as a setter method setFoo().\"\"\")\n"
  "\n"
  "    newSlot := method(name, value, \n"
  "	self setSlot(name, value)\n"
  "	self setSlot(\"set\" .. name asCapitalized, \n"
  "		doString(\"method(\" .. name .. \" = sender doMessage(thisMessage argAt(0)); self)\"))\n"
  "	value\n"
  "    )\n"
  "    \n"
  "    docSlot(\"launchFile(pathString)\", \n"
  "    \"Eval file at pathString as if from the command line in it's folder.\")\n"
  "    \n"
  "    launchFile := method(path, args,\n"
  "	args ifNil(args = List clone)\n"
  "	Lobby args := args\n"
  "	Lobby launchPath :=  path pathComponent\n"
  "	Directory setCurrentWorkingDirectory(Lobby launchPath)\n"
  "	self doFile(path)\n"
  "    )\n"
  "    \n"
  "    docSlot(\"println\", \"Same as print, but also prints a new line. Returns self.\")\n"
  "    println := method(self print; write(\"\\n\"); self)\n"
  "\n"
  "\n"
  "\n"
  "\n"
  "\n"
  "    docSlot(\"?(aMessage)\", \"\"\"\n"
  "    description: Sends the message aMessage to the receiver if it can respond to it. Example:\n"
  "    <pre>\n"
  "    MyObject test // performs test\n"
  "    MyObject ?test // performs test if MyObject has a slot named test\n"
  "    </pre>\n"
  "    The search for the slot only follows the receivers proto chain. \n"
  "    \"\"\")\n"
  "\n"
  "    setSlot(\"?\", method(\n"
  "	m := thisMessage argAt(0)\n"
  "	if (self getSlot(m name), self doMessage(m, sender), Nil)\n"
  "    ))\n"
  "\n"
  "    docSlot(\"ancestors\", \n"
  "    \"Returns a list of all of the receiver's ancestors as found by recursively following the protos links.\") \n"
  "\n"
  "  ancestors := method(a, \n"
  "	if(a, if(a contains(self), return a), a = List clone) \n"
  "	a append(self)\n"
  "	self protos foreach(p, p ancestors(a))\n"
  "	a\n"
  "  )\n"
  "    \n"
  "    docSlot(\"super(aMessage)\", \n"
  "    \"\"\"Sends the message aMessage to the receiver's proto with the context of self. Example:\n"
  "    <pre>\n"
  "    self test(1, 2)   // performs test(1, 2) on self\n"
  "    super(test(1, 2)) // performs test(1, 2) on self proto but with the context of self\n"
  "    </pre>\n"
  "    \"\"\")\n"
  "\n"
  "  setSlot(\"super\", method(\n"
  "	senderSlotContext := sender getSlot(\"slotContext\")\n"
  "	m := thisMessage argAt(0)\n"
  "	m ifNil(Exception raise(\"Object\", \"super requires an argument\"))\n"
  "	senderSlotContext ifNil(Exception raise(\"Object\", \"super called outside of block context\"))\n"
  "	slotName := m name\n"
  "	ancestor := senderSlotContext ancestorWithSlot(slotName)\n"
  "	if(ancestor == Nil or ancestor uniqueId == senderSlotContext uniqueId, Exception raise(\"Object\", \"super slot \" .. slotName .. \" not found\"))\n"
  "	ancestor getSlot(slotName) performOn(sender getSlot(\"self\"), sender, m, ancestor)\n"
  "))\n"
  "\n"
  "    docSlot(\"resend\", \n"
  "    \"\"\"Send the message used to activate the current method to the Object's proto.\n"
  "    For example;\n"
  "    <pre>\n"
  "    Dog := Mammal clone do(\n"
  "	init := method(\n"
  "	    resend\n"
  "	)\n"
  "    )\n"
  "    </pre>\n"
  "    calling Dog init will send an init method to Mammal, but using the Dog's context.\n"
  "    \"\"\")\n"
  "\n"
  "  setSlot(\"resend\", method(\n"
  "	senderSlotContext := sender getSlot(\"slotContext\")\n"
  "	senderSlotContext ifNil(Exception raise(\"Object\", \"resend called outside of block context\"))\n"
  "	m := sender thisMessage\n"
  "	slotName := m name\n"
  "	ancestor := senderSlotContext ancestorWithSlot(slotName)\n"
  "	if(ancestor == Nil or ancestor uniqueId == senderSlotContext uniqueId, Exception raise(\"Object\", \"resend slot \" .. slotName .. \" not found\"))\n"
  "	ancestor getSlot(slotName) performOn(sender getSlot(\"self\"), sender, m, ancestor)\n"
  "))\n"
  "  do := method(\n"
  "	self appendProto(sender)\n"
  "	self doMessage(thisMessage argAt(0), target)\n"
  "	self removeProto(sender)\n"
  "	self\n"
  "  )\n"
  "    \n"
  "    docSlot(\"list(...)\", \"Returns a List containing the arguments.\")\n"
  "    list := method(thisMessage argsEvaluatedIn(sender))\n"
  "    \n"
  "    docSlot(\"..(arg)\", \" .. is an alias for: method(arg, self asString append(arg asString))\")\n"
  "    setSlot(\"..\", method(arg, self asString appendSeq(arg asString)))\n"
  "\n"
  "    docSlot(\"newSlot(slotName, aValue)\", \"\"\"\n"
  "    description: Creates a getter and setter for the slot with the name slotName \n"
  "    and sets it's default the value aValue. Returns self. For example, \n"
  "    newSlot(\"foo\", 1) would create slot named foo with the value 1 as well as a setter method setFoo().\n"
  "    \"\"\")\n"
  "\n"
  "    newSlot := method(name, value, self setSlot(name, value); self setSlot(\"set\" .. name asCapitalized, doString(\"method(\" .. name .. \" = sender doMessage(thisMessage argAt(0)); self)\")); value)\n"
  "    \n"
  "    docSlot(\"println\", \"Same as print, but also prints a new line. Returns self.\")\n"
  "    println := method(self print; write(\"\\n\"); self)\n"
  "\n"
  "    docSlot(\"in(aList)\", \"Same as: aList contains(self)\")\n"
  "    in := method(aList, aList contains(self)) \n"
  ");\n"
  "Lobby IoVM ImmutableSequence := \"\"\n"
  "Lobby IoVM String := ImmutableSequence\n"
  "\n"
  "Sequence oldStringSlots := Map clone do(\n"
  "atPut(\"upper\", \"asUppercase\")\n"
  "atPut(\"lower\", \"asLowercase\")\n"
  "atPut(\"appendPath\", \"Path with(,)\")\n"
  "atPut(\"upper\", \"asUppercase\")\n"
  "atPut(\"removeFromTo\", \"removeSlice\")\n"
  "atPut(\"insert\", \"atInsertSeq(index, seq)\")\n"
  "atPut(\"fromTo\", \"slice\")\n"
  "atPut(\"substring\", \"slice\")\n"
  "atPut(\"beginsWith\", \"beginsWithSeq\")\n"
  "atPut(\"endsWith\", \"endsWithSeq\")\n"
  "atPut(\"after\", \"afterSeq\")\n"
  "atPut(\"before\", \"beforeSeq\")\n"
  "atPut(\"capitalized\", \"asCapitalized\")\n"
  "atPut(\"containsAnyCase\", \"containsAnyCaseSeq\")\n"
  "atPut(\"contains\", \"containsSeq\")\n"
  "atPut(\"swapIndexWithIndex\", \"swapIndices\")\n"
  "atPut(\"random\", \"anyOne\")\n"
  "atPut(\"randomize\", \"shuffle\")\n"
  "atPut(\"removeLastPathComponent\", \"pathComponent\")\n"
  "atPut(\"centered\", \"[no longer supported]\")\n"
  "atPut(\"leftJustified\", \"[no longer supported]\")\n"
  "atPut(\"rightJustified\", \"[no longer supported]\")\n"
  "atPut(\"length\", \"size\")\n"
  "atPut(\"find\", \"findSeq\")\n"
  ")\n"
  "\n"
  "//Lobby Protos IoVM Buffer := Sequence clone\n"
  "//Buffer before := method(s, i := self findSeq(s); if (i == Nil, self, slice(0, i)))\n"
  "//Buffer after  := method(s, i := self findSeq(s); if (i == Nil, Nil, slice(i + s size, size)))\n"
  "\n"
  "Sequence forward := method(\n"
  "	slotName := thisMessage name\n"
  "	newSlot := oldStringSlots at(slotName)\n"
  "	if (newSlot, Exception raise(\"Sequence\", \"does not respond to \" .. slotName .. \" (this method has been replaced by \" .. newSlot .. \")\"))\n"
  "	Exception raise(\"Sequence\", \"does not respond to \" .. slotName)\n"
  ")\n"
  "\n"
  "Sequence do(\n"
  "    makeFirstCharacterLowerCase := method(\n"
  "	if(self size > 0, self atPut(0, self at(0) asLowerCase))\n"
  "    )\n"
  "\n"
  "    makeFirstCharacterUpperCase := method(\n"
  "	if(self size > 0, self atPut(0, self at(0) asUpperCase))\n"
  "    )\n"
  "\n"
  "    slicesBetween := method(startSeq, endSeq,\n"
  "	chunks := List clone\n"
  "	lastIndex := 0\n"
  "	while (startIndex := self findSeq(startSeq, lastIndex),\n"
  "	    endIndex := self findSeq(endSeq, startIndex + startSeq size)\n"
  "	    endIndex ifNil(break)\n"
  "	    chunks append(self slice(startIndex + startSeq size, endIndex))\n"
  "	    lastIndex := endIndex + endSeq size\n"
  "	)\n"
  "	chunks\n"
  "    )\n"
  ")\n"
  "\n"
  "/*\n"
  "Sequence pySplit := method(sep,\n"
  "    result := List clone\n"
  "    last := 0\n"
  "    i := 0\n"
  "    while (i = findSeq(sep, i),\n"
  "        result append(slice(last, i))\n"
  "        last = i+1\n"
  "        i = i + 1\n"
  "    )\n"
  "    result append(slice(last, size))\n"
  "    result\n"
  ")\n"
  "*/\n"
  ";\n"
  "Date secondsToRun := method(\n"
  "	t1 := Date clone now\n"
  "	sender doMessage(thisMessage argAt(0))\n"
  "	dt := Date clone now secondsSince(t1)\n"
  ");\n"
  "\n"
  "Directory do(\n"
  "    docSlot(\"with(aPath)\", \"Returns a new instance with the provided path.\")\n"
  "    with := method(path, self clone setPath(path))\n"
  "\n"
  "    parentDirectory := method(\n"
  "	if (path == \".\", return Nil)\n"
  "	p := self path removeLastPathComponent	\n"
  "	if (p == \"\", p = \".\")\n"
  "	Directory clone setPath(p)\n"
  "    )\n"
  "\n"
  "    folders := method(\n"
  "	self items select(i, item, item type == \"Directory\" and item name beginsWithSeq(\".\") == Nil)\n"
  "    )\n"
  "\n"
  "    isAccessible := method(\n"
  "        r := self\n"
  "	try (self items) catch(Exception, e, r = Nil)\n"
  "	r\n"
  "    )\n"
  "\n"
  "    parents := method(\n"
  "	list := List clone\n"
  "	d := self\n"
  "	while(d = d parentDirectory, list append(d))\n"
  "	list reverse\n"
  "    )\n"
  "\n"
  "    accessibleParents := method(\n"
  "	parents select(i, p, p isAccessible)\n"
  "    )\n"
  "    \n"
  "    files := method(\n"
  "	//writebr(\"path = \", path)\n"
  "	items select(i, v, v type == \"File\")\n"
  "    )\n"
  "    \n"
  "    fileNames := method(\n"
  "	files mapInPlace(i, v, v name)\n"
  "    )\n"
  "    \n"
  "    fileNamed := method(name,\n"
  "	files detect(i, v, v name == name)\n"
  "	//File clone setPath(Path with(path, name))\n"
  "    )\n"
  "\n"
  "    filesWithExtension := method(ext,\n"
  "      if (ext containsSeq(\".\") == Nil, ext = \".\" .. ext)\n"
  "      files select(f, f name endsWithSeq(ext))\n"
  "    )\n"
  "\n"
  "    folderNamed := method(name,\n"
  "	folders detect(i, v, v name == name)\n"
  "    )\n"
  "\n"
  "    remove := method(\n"
  "        File clone setPath(self path) remove\n"
  "    )\n"
  "\n"
  "    folderNamedCreateIfAbsent := method(name,\n"
  "	f := folderNamed(name)\n"
  "	if (f, return f)\n"
  "	createSubdirectory(name)\n"
  "	folderNamed(name)\n"
  "    )\n"
  "\n"
  "    createFileNamed := method(name,\n"
  "	f := fileNamed(name)\n"
  "	if (f, return f)\n"
  "	return File clone setPath(Path with(path, name))\n"
  "    )\n"
  ")\n"
  "\n"
  "\n"
  ";\n"
  "\n"
  "File do(\n"
  "	docSlot(\"asSeq\", \"Returns the contents of the file as a mutable Sequence.\")\n"
  "	asSeq := method(self asString asMutable)\n"
  "\n"
  "	docSlot(\"with(aPath)\", \"Returns a new instance with the provided path.\")\n"
  "	with := method(path, self clone setPath(path))\n"
  ")\n"
  "\n"
  "\n"
  ";\n"
  "\n"
  "List do(\n"
  "    docSlot(\"sum\", \"Returns the sum of the items.\")\n"
  "    sum := method(s := 0; self foreach(v, s = s + v); s)\n"
  "\n"
  "    docSlot(\"average\", \"Returns the average of the items.\")\n"
  "    average := method(self sum / self size)\n"
  "\n"
  "    docSlot(\"shuffle\", \"Randomizes the order of the elements in the receiver. Returns self.\")\n"
  "    shuffle := method(for(i, 1, size - 1, swapIndices(i, Random value(i, size) floor)))\n"
  "\n"
  "    docSlot(\"anyOne\", \"Returns a random element of the receiver or Nil if the receiver is empty.\")\n"
  "    anyOne := method(at(Random value(0, size) floor))\n"
  " \n"
  "    docSlot(\"removeFirst\", \"Returns the first item and removes it from the list. Nil is returned if the list is empty.\")\n"
  "    removeFirst := method(if(self size != 0, removeAt(0)))\n"
  "\n"
  "    docSlot(\"removeLast\", \"Returns the last item and removes it from the list. Nil is returned if the list is empty.\")\n"
  "    removeFirst := method(self pop)\n"
  "\n"
  "    docSlot(\"join(optionalString)\", \"Returns a Sequence of the concatenated items with optionalString between each item or simply the concatenation of the items if no optionalString is supplied.\")\n"
  "    join := method(arg,\n"
  "	s := Sequence clone\n"
  "	if (arg) then (\n"
  "	    max := self size - 1\n"
  "	    self foreach(i, v, s appendSeq(v); if(i != max, s appendSeq(arg)))\n"
  "	) else (\n"
  "	    self foreach(v, s appendSeq(v))\n"
  "	)\n"
  "	s\n"
  "    )\n"
  "\n"
  "    docSlot(\"insertAfter(item, afterItem)\", \"Inserts item after first occurance of afterItem and returns self. If afterItem is not found, item is appended to the end of the list.\")\n"
  "    insertAfter := method(item, afterItem,\n"
  "       i := self indexOf(afterItem) \n"
  "       if(i, self atInsert(i + 1, item), self append(item))\n"
  "       self\n"
  "    )\n"
  "\n"
  "    docSlot(\"insertBefore(item, beforeItem)\", \"Inserts item before first occurance of beforeItem or to the end of the list if beforeItem is not found. Returns self.\")\n"
  "    insertBefore := method(item, beforeItem,\n"
  "       i := self indexOf(beforeItem)\n"
  "       if(i, self atInsert(i, item), self append(item))\n"
  "       self\n"
  "    )\n"
  "\n"
  "    docSlot(\"insertAt(item, index)\", \"Inserts item at the specified index. Raises an exception if the index is out of bounds. Returns self.\")\n"
  "    insertAt := method(item, index, self atInsert(index, item))\n"
  ");\n"
  "Number constants := Object clone do(\n"
  "    docSlot(\"constants pi\", \"Returns the constant pi.\")\n"
  "    pi := 3.14159265358979323846264338327950288\n"
  "\n"
  "    docSlot(\"constants NaN\", \"Returns a Not a Number constant.\")    \n"
  "    NaN := (1/0)\n"
  "    \n"
  "    docSlot(\"constants e\", \"Returns the constant e.\")\n"
  "    e  := 2.71828182845904523536028747135266249\n"
  ");\n"
  "CGI := Object clone do(\n"
  "\n"
  "docCopyright(\"Steve Dekorte\", 2004)\n"
  "docLicense(\"BSD revised\")\n"
  "docDescription(\"\"\"\n"
  "CGI supports accessing CGI parameters passed in environment variable or standard input by a web servers like Apache.Example use;\n"
  "<pre>\n"
  "#!./ioServer\n"
  "\n"
  "write(\"Content-type:text/html\\n\\n\")\n"
  "write(\"&lt;!doctype html public \\\"-//W3C/DTD HTML 4.0/EN\\\"&gt;\\n\")\n"
  "write(\"Got the following CGI parameters:&lt;PRE&gt;\")\n"
  "\n"
  "form = CGI clone parse\n"
  "\n"
  "if(form) then (\n"
  "  form foreach(k, v, write(\"  \", k, \" = \", v, \"&lt;BR&gt;\"))\n"
  ") else ( \n"
  "  write(\"no form variables found\\n\") \n"
  ")</pre>\"\"\")\n"
  "\n"
  "    docSlot(\"parse\", \"Parses the QUERY_STRING environment variable (or standard input if there is no QUERY_STRING environment variable) and returns a Map containing key/value query value pairs.\")\n"
  "\n"
  "    parse := method(\n"
  "      q := System getenv(\"QUERY_STRING\")\n"
  "      contentLength := System getenv(\"CONTENT_LENGTH\")\n"
  "      \n"
  "      if (contentLength, \n"
  "	post := File clone standardInput readStringOfLength(contentLength asNumber)\n"
  "	q = if (q != \"\", q .. \"&\" .. post, post)\n"
  "      )\n"
  "      //write(\"<PRE> q := \", q, \"</PRE>\\n\")\n"
  "      return self parseString(q)\n"
  "    )\n"
  "\n"
  "    parseString := method(q, \n"
  "      q = q asMutable replaceSeq(\"+\", \" \")\n"
  "\n"
  "      form := Map clone\n"
  "      q split(\"&\") foreach(i, v, \n"
  "	kv := v split(\"=\")\n"
  "	if(kv size == 2) then (\n"
  "	  k := kv at(0)\n"
  "	  v := decodeUrlParam(kv at(1))\n"
  "\n"
  "	  if (form hasKey(k), \n"
  "	    vallist := List clone\n"
  "\n"
  "	    // this already exists, so we want to take the value of k, \n"
  "	    // and make a list of the values, \n"
  "	    // remove the original k/v then add k/v as list back.\n"
  "\n"
  "	    if (form at(k) type == \"List\", \n"
  "		    //it's a list already, so just add the value at the end\n"
  "		    vallist = form at(k)\n"
  "		    vallist add(v)\n"
  "	    ) else (\n"
  "		    vallist add(form at(k))  \n"
  "		    vallist add(v)\n"
  "	    )\n"
  "\n"
  "	    form removeAt(k)\n"
  "	    form atPut(k, vallist)\n"
  "	  )  else (\n"
  "	    form atPut(k, v)\n"
  "	  )\n"
  "	) else ( \n"
  "	  kv := kv at(0) split(\",\")\n"
  "	  form atPut(\"imageMapX\", kv at(0))\n"
  "	  form atPut(\"imageMapY\", kv at(1))\n"
  "	)\n"
  "      )\n"
  "      return form\n"
  "    )\n"
  "\n"
  "    urlCodes := Map clone\n"
  "\n"
  "    setup := method(\n"
  "      for (i, 0, 255,\n"
  "	code := i asString toBase(16) asUppercase\n"
  "	if (code size == 1, code = \"0\" .. code)\n"
  "	/*write(i, \" := \", i asCharacter, \" := \", \"%\" .. code, \"<BR>\")*/\n"
  "	urlCodes atPut(i asCharacter, \"%\" .. code) \n"
  "      )\n"
  "    )\n"
  "\n"
  "    setup\n"
  "\n"
  "    urlPlains := Map clone do(\n"
  "	    atPut(\" \", \"+\")\n"
  "	    atPut(\"*\", \"*\")\n"
  "	    atPut(\"-\", \"-\")\n"
  "	    atPut(\".\", \".\")\n"
  "	    for (i, 48, 57, atPut(i asCharacter, i asCharacter))\n"
  "	    for (i, 65, 90, atPut(i asCharacter, i asCharacter))\n"
  "	    atPut(\"_\", \"_\")\n"
  "	    for (i, 97, 122, atPut(i asCharacter, i asCharacter))\n"
  "    )\n"
  "\n"
  "    docSlot(\"encodeUrlParam(aString)\", \"Returns a URL encoded version of aString.\")\n"
  "\n"
  "    encodeUrlParam := method(sIn,\n"
  "	    sOut := Sequence clone\n"
  "	    sIn foreach(i, v,\n"
  "		    c := v asCharacter\n"
  "		    p := urlPlains at(c)\n"
  "		    sOut appendSeq(if(p, p, urlCodes at(c)))\n"
  "	    )\n"
  "	    return sOut asString\n"
  "    )\n"
  "\n"
  "    docSlot(\"decodeUrlParam(aString)\", \"Returns a URL decoded version of aString.\")\n"
  "\n"
  "    decodeUrlParam := method(s,\n"
  "      urlCodes foreach(k, v, s = s replaceSeq(v, k))\n"
  "      return s\n"
  "    )\n"
  "\n"
  ")\n"
  ";\n"
  "\n"
  "Sandbox do(\n"
  "    docSlot(\"printCallback(string)\", \n"
  "     \"default implementation is; method(string, string print)\")\n"
  "    printCallback := method(string, string print)\n"
  ");\n"
  "docSlot(\"getOptions(args)\", \"\"\"\n"
  "	This primitive is used to get command line options similar to Cs getopt(). \n"
  "	It returns a map in containing the left side of the argument, with the \n"
  "	value of the right side. (The key will not contain\n"
  "	the beginning dashes (--).\n"
  " 	<p>\n"
  "	Example:\n"
  " 	<pre>\n"
  "	options := System getOptions(args)\n"
  "	options foreach(k, v,\n"
  "	  if(v type == List type,\n"
  "	    v foreach(i, j, writeln(\"Got unnamed argument with value: \" .. j))\n"
  "	    continue\n"
  "	  )\n"
  "	  writeln(\"Got option: \" .. k .. \" with value: \" .. v)\n"
  "	)\n"
  " 	</pre>\n"
  "\"\"\")\n"
  "\n"
  "\n"
  "System do(\n"
  "  getOptions := method(arguments,\n"
  "    opts := Map clone\n"
  "    optname := Sequence clone\n"
  "    optvalue := Sequence clone\n"
  "    optsNoKey := List clone\n"
  "  \n"
  "    arguments foreach(i, arg,\n"
  "      if(arg beginsWithSeq(\"--\") isNil) then(\n"
  "        optsNoKey append(arg)\n"
  "        continue\n"
  "      )\n"
  "      if(arg containsSeq(\"=\")) then(\n"
  "        optname = arg clone asMutable clipAfterStartOfSeq(\"=\") clipBeforeEndOfSeq(\"--\")\n"
  "        optvalue = arg clone asMutable clipBeforeEndOfSeq(\"=\")\n"
  "      ) else(\n"
  "        optname = arg clone asMutable clipBeforeEndOfSeq(\"--\")\n"
  "        optvalue = \"\"\n"
  "      )\n"
  "      opts atPut(optname, optvalue)\n"
  "    )\n"
  "    if(optsNoKey last != Nil, opts atPut(\"\", optsNoKey))\n"
  "    opts\n"
  "  )\n"
  ")\n"
  "\n"
  ";\n"
  "Path := Object clone do(\n"
  "	with := method(\n"
  "		s := Sequence clone\n"
  "		thisMessage arguments foreach(arg,\n"
  "			s appendPathSeq(sender doMessage(arg))\n"
  "		)\n"
  "		s asSymbol\n"
  "	)\n"
  ")\n"
  "\n"
  ";\n"
  "Importer := Object clone do(\n"
  "    docDescription(\"A simple search path based auto-importer.\")\n"
  "\n"
  "    paths := List clone append(\"\")\n"
  "    debug := Nil\n"
  "    addSearchPath := method(p, paths append(p))\n"
  "    extensions := list(\"io\")\n"
  "\n"
  "    executeString := method(name, s,\n"
  "	Lobby doString(s, name)\n"
  "	r := Lobby getSlot(name)\n"
  "	if(r, return r)\n"
  "	Exception raise(\"Importer\", \"slot '\" .. name .. \"' missing after file load\")\n"
  "	Nil    \n"
  "    )\n"
  "    \n"
  "    execute_io := method(path, name, extension,\n"
  "	p := Path with(path, name .. \".\" .. extension)\n"
  "	s := File clone setPath(p) asBuffer\n"
  "	executeString(name, s)\n"
  "    )\n"
  "\n"
  "    find := method(name, theObject,\n"
  "	p := ?launchPath\n"
  "	if(p and paths contains(p) == Nil, paths atInsert(0, p))  \n"
  "	if(name at(0) isUpperCase, paths foreach(p, \n"
  "	    extensions foreach(extension,\n"
  "		fullPath := Path with(p, name .. \".\" .. extension)\n"
  "		if(debug, write(\"Importer search:\", p, \"\\n\"))\n"
  "		if(File clone setPath(fullPath) exists, \n"
  "		    r := self perform(\"execute_\" .. extension, p, name, extension)\n"
  "		    if (r, return r)\n"
  "		)\n"
  "	    )\n"
  "	  )\n"
  "	)\n"
  "	Exception raise(\"Importer\", theObject type .. \" does not respond to '\" .. name .. \"'\")\n"
  "    )\n"
  "\n"
  "    docSlot(\"turnOn\", \"Turns on the Importer. Returns self.\")    \n"
  "    turnOn := method(Lobby forward := method(Importer find(thisMessage name, self)); self)\n"
  "\n"
  "    docSlot(\"turnOff\", \"Turns off the Importer. Returns self.\")    \n"
  "    turnOff := method(Lobby removeSlot(\"forward\"); self)\n"
  "    turnOn\n"
  ");\n"
  "";

  IoObject_rawDoString_label_(context, SIOSYMBOL(s), SIOSYMBOL("VMCode"));
}
