Lobby IoVM ImmutableSequence := ""
Lobby IoVM String := ImmutableSequence

Sequence oldStringSlots := Map clone do(
atPut("upper", "asUppercase")
atPut("lower", "asLowercase")
atPut("appendPath", "Path with(,)")
atPut("upper", "asUppercase")
atPut("removeFromTo", "removeSlice")
atPut("insert", "atInsertSeq(index, seq)")
atPut("fromTo", "slice")
atPut("substring", "slice")
atPut("beginsWith", "beginsWithSeq")
atPut("endsWith", "endsWithSeq")
atPut("after", "afterSeq")
atPut("before", "beforeSeq")
atPut("capitalized", "asCapitalized")
atPut("containsAnyCase", "containsAnyCaseSeq")
atPut("contains", "containsSeq")
atPut("swapIndexWithIndex", "swapIndices")
atPut("random", "anyOne")
atPut("randomize", "shuffle")
atPut("removeLastPathComponent", "pathComponent")
atPut("centered", "[no longer supported]")
atPut("leftJustified", "[no longer supported]")
atPut("rightJustified", "[no longer supported]")
atPut("length", "size")
atPut("find", "findSeq")
)

//Lobby Protos IoVM Buffer := Sequence clone
//Buffer before := method(s, i := self findSeq(s); if (i == Nil, self, slice(0, i)))
//Buffer after  := method(s, i := self findSeq(s); if (i == Nil, Nil, slice(i + s size, size)))

Sequence forward := method(
	slotName := thisMessage name
	newSlot := oldStringSlots at(slotName)
	if (newSlot, Exception raise("Sequence", "does not respond to " .. slotName .. " (this method has been replaced by " .. newSlot .. ")"))
	Exception raise("Sequence", "does not respond to " .. slotName)
)

Sequence do(
    makeFirstCharacterLowerCase := method(
	if(self size > 0, self atPut(0, self at(0) asLowerCase))
    )

    makeFirstCharacterUpperCase := method(
	if(self size > 0, self atPut(0, self at(0) asUpperCase))
    )

    slicesBetween := method(startSeq, endSeq,
	chunks := List clone
	lastIndex := 0
	while (startIndex := self findSeq(startSeq, lastIndex),
	    endIndex := self findSeq(endSeq, startIndex + startSeq size)
	    endIndex ifNil(break)
	    chunks append(self slice(startIndex + startSeq size, endIndex))
	    lastIndex := endIndex + endSeq size
	)
	chunks
    )
)

/*
Sequence pySplit := method(sep,
    result := List clone
    last := 0
    i := 0
    while (i = findSeq(sep, i),
        result append(slice(last, i))
        last = i+1
        i = i + 1
    )
    result append(slice(last, size))
    result
)
*/
