/*   
 *   copyright: Steve Dekorte, 2002. All rights reserved.
 *   license: See _BSDLicense.txt.
 *
 */

#ifndef IoBufferEnumerator_DEFINED
#define IoBufferEnumerator_DEFINED 1

#include "base/Common.h"
#include "base/ByteArray.h"
#include "IoObject.h"
#include "IoNumber.h"

#ifdef __cplusplus
extern "C" {
#endif

#define ISBUFFERENUMERATOR(self) IoObject_hasCloneFunc_(self, (TagCloneFunc *)IoBufferEnumerator_rawClone)

typedef IoObject IoBufferEnumeratorData;

typedef struct
{
    IoBuffer *buffer;
    IoList *stopStrings;
    size_t position;
} IoBufferEnumeratorData;

IoBufferEnumerator *IoBufferEnumerator_proto(void *state);
IoBufferEnumerator *IoBufferEnumerator_rawClone(IoBufferEnumerator *self);
IoBufferEnumerator *IoBufferEnumerator_new(void *state);
IoBufferEnumerator *IoBufferEnumerator_newForBuffer_(void *state, IoBuffer *buffer);

void IoBufferEnumerator_mark(IoBufferEnumerator *self);
void IoBufferEnumerator_free(IoBufferEnumerator *self);
int IoBufferEnumerator_compare(IoBufferEnumerator *self, IoBufferEnumerator *v);

IoObject *IoBufferEnumerator_rewind(IoBufferEnumerator *self, IoObject *locals, IoMessage *m);

IoObject *IoBufferEnumerator_position(IoBufferEnumerator *self, IoObject *locals, IoMessage *m);
IoObject *IoBufferEnumerator_setPosition(IoBufferEnumerator *self, IoObject *locals, IoMessage *m);

IoObject *IoBufferEnumerator_next(IoBufferEnumerator *self, IoObject *locals, IoMessage *m);

IoObject *IoBufferEnumerator_setStopStrings(IoBufferEnumerator *self, IoObject *locals, IoMessage *m);
IoObject *IoBufferEnumerator_stopStrings(IoBufferEnumerator *self, IoObject *locals, IoMessage *m);


#ifdef __cplusplus
}
#endif
#endif
