/*#io
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
*/

#ifndef IoCoroutine_DEFINED
#define IoCoroutine_DEFINED 1

#include "Common.h"
#include "IoObject.h"
#include "IoList.h"
#include "Hash.h"

#ifdef __cplusplus
extern "C" {
#endif

#define ISCOROUTINE(self) IoObject_hasCloneFunc_(self, (TagCloneFunc *)IoCoroutine_rawClone)

typedef IoObject IoCoroutine;

typedef struct
{
    Coro *cid;
    Stack *retainedValues;
    void *exceptionCatch;
    void *exception;
    int debuggingOn;
} IoCoroutineData;

IoCoroutine *IoCoroutine_proto(void *state);
IoCoroutine *IoCoroutine_rawClone(IoCoroutine *self);
IoCoroutine *IoCoroutine_new(void *state);
void IoCoroutine_free(IoCoroutine *self);
void IoCoroutine_mark(IoCoroutine *self);

void IoCoroutine_writeToStore_stream_(IoCoroutine *self, IoStore *store, BStream *stream);
void IoCoroutine_readFromStore_stream_(IoCoroutine *self, IoStore *store, BStream *stream);

/* ----------------------------------------------------------- */

Stack *IoCoroutine_rawRetainedValues(IoCoroutine *self);
int IoCoroutine_rawRetainingCount(IoCoroutine *self);
void IoCoroutine_rawShow(IoCoroutine *self);

/* ----------------------------------------------------------- */

IoObject *IoCoroutine_retainedValues(IoCoroutine *self, IoObject *locals, IoMessage *m);

#ifdef __cplusplus
}
#endif
#endif
