/*   
 *   copyright: Steve Dekorte, 2002. All rights reserved.
 *   license: See _BSDLicense.txt.
 */

#ifndef IoPObject_DEFINED
#define IoPObject_DEFINED 1

#include "base/Common.h"
#include "IoObject.h"
#include "IoState.h"
#include "IoMessage.h"

#define ISPObject(self) (self->tag->cloneFunc==(TagCloneFunc*)IoPObject_rawClone)
#define ISWAITINGPOBJECT(self) (ISPObject(self) && (!(self->proto)))

typedef IoObject IoPObject;

typedef struct
{
  IoStore *store;
} IoPObjectData;

IoPObject *IoPObject_proto(void *state);
IoPObject *IoPObject_rawClone(IoPObject *self);
IoPObject *IoPObject_new(void *state);
IoPObject *IoPObject_newWithStore_pid_(IoState *state, IoStore *store, int pid);
void IoPObject_mark(IoPObject *self);
void IoPObject_free(IoPObject *self);

void IoPObject_rawSetObject_(IoPObject *self, IoObject *v);

IoObject *IoPObject_forward(IoPObject *self, IoObject *locals, IoMessage *m);

#endif
