
// The coroutine in the Generator stays around and processes 
// a little bit each time "next(v)" is invoked.

Generator := Object clone do(
    value := 0
    input := 0
    next := method(v, 
      input = v
      self resume
      yield
      value
    )

    run := method(
      for(i, 0, 1000, 
	value = i + input
	self pause
      )
      value = Nil
    )
)

Generator @run
output := Buffer clone
output appendSeq(Generator next(10) asString, ", "); yield
output appendSeq(Generator next(100) asString, ", "); yield
output appendSeq(Generator next(1000) asString); yield


write(output, "\n")
write("output should have been: 10, 101, 1002\n")
if (output == "10, 101, 1002", write("OK\n"), write("FAILED\n"))
