// From QuantumG

Runner := Lobby clone do( 
  run := method(msg,
    self turnOnMessageDebugging
    doString(msg)
  )
)

Debugger vmWillSendMessage = method(actor, msg, target, context,
  writeln(msg asString)
  continue := 1
  while(continue,
    write("> ")
    line := File standardInput readLine
    cmd := line split(" ") at(0)
    if (cmd == Nil, cmd = "")
    rest := line slice(cmd size + 1)

    if (cmd == "step" or cmd == "s" or cmd == "",
      continue = Nil,

    if (cmd == "print" or cmd == "p",
      writeln(context doString(rest), "\n"),

    if (cmd == "target",
      writeln(target),

    if (cmd == "context",
      writeln(context),

    // else
      writeln("unknown command: ", cmd)
    ))))
  )
  actor ?resume
)

Debugger debug := method(msg,
  Runner @@run(msg)
)

so you can just add doFile("debug.io") to the top of the file and add 
Debugger debug("SomeObject someMethod(arg1, arg2)") and you should get a 
nice command line which you can use to step through the code and inspect 
variables.
