
//debugCollector := 1


basicTests := method(
  Lobby doFile("tests/Account.io")
  Lobby doFile("tests/Blocks.io")
  Lobby doFile("tests/Conditions.io")
  Lobby doFile("tests/ControlFlow.io")
  Lobby doFile("tests/Exceptions.io")
)

total := 0

dir := Path with(launchPath, "/performance/")
totals := List clone
addTotal := method(name, time, 
  obj := Object clone
  obj name := name
  obj time := time
  totals add(obj)
)

runit := method(fileName, arg, arg2,
  path := Path with(dir, fileName)
  write("\n", path lastPathComponent, " ", arg asString lastPathComponent, " ", if(arg2, arg2, ""), "\n")
  write("---------------------\n")
  //t := Date secondsToRun(Lobby doFile(path, arg, arg2))
  t := Date clone now
  //write("now:", t, "\n")
  System system("./io " .. path .." ".. arg)
  //write("now2:", Date now, "\n")
  d := Date clone now - t
  //write("d:", d, "\n")
  //write("[", d asNumber, " seconds]\n")
  write("\n")
  addTotal(fileName, d)
  total = total + d asNumber
)

runit("methcall.io", 100000)
runit("objinst.io", 100000)

runit("hash.io", 30000)
runit("hash2.io", 20)

runit("ary.io", 1000)
runit("ary3.io", 1000)
runit("lists.io", 6)

runit("strcat.io", 300000)
runit("except.io", 10000)
runit("nestedloop.io", 12)
runit("random.io", 100000)

// --- other tests ---

runit("fibo.io", 10)
runit("sieve.io", 3)
runit("sumcol.io", Path with(dir, "data/columns.txt"))
runit("wc.io", Path with(dir, "data/prince.txt"))
runit("wordfreq.io", Path with(dir, "data/prince.txt"))

////runit("heapsort.io", 10)
runit("hello.io", 10)
////runit("matrix.io", 10)
//runit("moments.io", Path with(dir, "data/columns.txt"))
//runit("regexmatch.io", 10)
//runit("reversefile.io", Path with(dir, "data/prince.txt"))
//runit("spellcheck.io", 
//  Path with(dir, "data/words"), 
//  Path with(dir, "data/prince.txt"))


write("\n")

totals sortBy(block(x, y, x time < y time))

totals foreach(test, 
  t := test time totalSeconds * (1000) floor asString
  write(test name leftJustified(15), t rightJustified(6), " ms\n")
)

write("\n")
write("total:" leftJustified(15), (total * 1000) floor asString rightJustified(6), " ms\n\n")



