
WarningTest := TestCase clone do(

    testIsResumable := method(
        Warning isResumable
    )

    testExceptionLineNumbers := method(
        try (
            Warning raise("test", "test")
        ) catch (Warning, e, 
            m := e ?caughtMessage
            assertNotNil(m)
            if (e ?caughtMessage != Nil,
                assertNotNil(m ?label)
                assertNotNil(m ?lineNumber)
            )
        )
    )

    testRaise := method(
        assertRaisesException( Warning raise("foo", "bar") )
    )

/*
    testRaiseNotIsResumable := method(
        try (
            Warning raise("blah", "blah")
            fail
        ) catch (Warning, e, 
            knownBug(assertFalse(e isResumable))
        )
    )

    testRaiseNotResumable := method(
        try (
            Warning raise("blah", "blah")
            fail
        ) catch (Warning, e, 
            knownBug(e resume)
        )
    )

    testRaiseResumable := method(
        try (
            Warning raiseResumable("blah", "blah")
            fail
        ) catch (Warning, e, 
            assertTrue(e isResumable)
        )
    )
/*
    testResumeException := method(
        flag := Nil
        try (
            Warning raiseResumable("blah", "blah")
            assertTrue(flag)
        ) catch (Warning, e, 
            assertTrue(e isResumable)
            flag = 1
            knownBug(e resume)
        )
    )
*/
    testBackTrace := method(
        knownBug(Warning backTraceString)
    )
)
